/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.Isolines;

import javax.swing.JPanel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.mappers.Isolines.IsolinesShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 * <p>
 * @modified by Szpak
 */
public class IsolinesGUI extends JPanel
{
    private ParameterProxy parameterProxy;
    private boolean[] aCS = null;


    /**
     * Creates new form IsosurfaceUI
     */
    public IsolinesGUI()
    {
        initComponents();
        preprocessingPanel.setVisible(preprocessingSectionHeader.isExpanded());
    }

    public void setParameterProxy(ParameterProxy targetParameterProxy)
    {
        //putting run button between logic and gui
        parameterProxy = runButton.getPlainProxy(targetParameterProxy, RUNNING_MESSAGE);
        cropUI.setParameterProxy(parameterProxy);
        thresholdsUI.setComponentValuesArray(parameterProxy.get(THRESHOLDS));
        parameterProxy.get(THRESHOLDS).setUI(thresholdsUI);
    }

    void updateGUI(final ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        if (p.get(THRESHOLDS).getComponentSchema() != null)
            updateTimeSlider(p.get(THRESHOLDS).getComponentSchema().getTimeDataSchema().getTimesAsArray(), p.get(TIME), resetFully);
        uncertaintyBox.setEnabled(p.get(META_REGULAR_DIMS) == 2);
        bdrCheckBox.setEnabled(p.get(META_REGULAR_DIMS) != 2);
        uncertaintyBox.setSelected(p.get(COMPUTE_UNCERTAINTY));
        cellSetScrollPane.setVisible(p.get(META_REGULAR_DIMS) == -1);
        cellSetList.setListData(p.get(META_CELL_SET_NAMES));
        preprocessingRegularPanel.setVisible(p.get(META_REGULAR_DIMS) == 2);
        cropUI.updateGUI(p, resetFully);
        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

    public void updateTimeSlider(float[] range, float value, boolean resetRange)
    {
        timeSlider.setVisible(range.length > 1);
        if (range.length < 2)
            return;
        timeSlider.setValue(value);
        if (resetRange) {
            timeSlider.setMin(range[0]);
            timeSlider.setMax(range[range.length - 1]);
        }
        //always reset global range
        timeSlider.setGlobalMin(range[0]);
        timeSlider.setGlobalMax(range[range.length - 1]);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        preprocessingRegularPanel = new javax.swing.JPanel();
        preprocessingSectionHeader = new org.visnow.vn.gui.widgets.SectionHeader();
        preprocessingPanel = new javax.swing.JPanel();
        cropPresentationPanel = new javax.swing.JPanel();
        cropUI = new org.visnow.vn.lib.gui.cropUI.CropUI();
        thresholdPanel = new javax.swing.JPanel();
        timeSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        uncertaintyBox = new javax.swing.JCheckBox();
        thresholdsUI = new org.visnow.vn.lib.gui.ComponentBasedUI.array.ComponentValuesArrayUI();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        cellSetScrollPane = new javax.swing.JScrollPane();
        cellSetList = new javax.swing.JList();
        bdrCheckBox = new javax.swing.JCheckBox();

        setLayout(new java.awt.GridBagLayout());

        preprocessingRegularPanel.setLayout(new java.awt.GridBagLayout());

        preprocessingSectionHeader.setExpanded(false);
        preprocessingSectionHeader.setShowCheckBox(false);
        preprocessingSectionHeader.setText("Preprocessing");
        preprocessingSectionHeader.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                preprocessingSectionHeaderUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        preprocessingRegularPanel.add(preprocessingSectionHeader, gridBagConstraints);

        preprocessingPanel.setLayout(new java.awt.GridBagLayout());

        cropPresentationPanel.setLayout(new java.awt.GridBagLayout());

        cropUI.setDynamic(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        cropPresentationPanel.add(cropUI, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        preprocessingPanel.add(cropPresentationPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 16, 0);
        preprocessingRegularPanel.add(preprocessingPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(preprocessingRegularPanel, gridBagConstraints);

        thresholdPanel.setLayout(new java.awt.GridBagLayout());

        timeSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        timeSlider.setGlobalMax(1);
        timeSlider.setGlobalMin(0);
        timeSlider.setSubmitOnAdjusting(false);
        timeSlider.setValue(0.5);
        timeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("Time:"));
        timeSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                timeSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        thresholdPanel.add(timeSlider, gridBagConstraints);

        uncertaintyBox.setText("Create uncertainty component");
        uncertaintyBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                uncertaintyBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        thresholdPanel.add(uncertaintyBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        thresholdPanel.add(thresholdsUI, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(thresholdPanel, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                runButtonUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(16, 0, 0, 0);
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.weighty = 1.0;
        add(filler, gridBagConstraints);

        cellSetScrollPane.setMinimumSize(new java.awt.Dimension(50, 60));
        cellSetScrollPane.setPreferredSize(new java.awt.Dimension(50, 100));

        cellSetList.setEnabled(false);
        cellSetList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                cellSetListValueChanged(evt);
            }
        });
        cellSetScrollPane.setViewportView(cellSetList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(cellSetScrollPane, gridBagConstraints);

        bdrCheckBox.setText("draw isolines on boundaries");
        bdrCheckBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                bdrCheckBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(bdrCheckBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void uncertaintyBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_uncertaintyBoxActionPerformed
    {//GEN-HEADEREND:event_uncertaintyBoxActionPerformed
        parameterProxy.set(COMPUTE_UNCERTAINTY, uncertaintyBox.isSelected());
    }//GEN-LAST:event_uncertaintyBoxActionPerformed

    private void preprocessingSectionHeaderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_preprocessingSectionHeaderUserChangeAction
    {//GEN-HEADEREND:event_preprocessingSectionHeaderUserChangeAction
        preprocessingPanel.setVisible(preprocessingSectionHeader.isExpanded());
    }//GEN-LAST:event_preprocessingSectionHeaderUserChangeAction

    private void timeSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_timeSliderUserChangeAction
    {//GEN-HEADEREND:event_timeSliderUserChangeAction
        parameterProxy.set(TIME, (Float) timeSlider.getValue());
    }//GEN-LAST:event_timeSliderUserChangeAction

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameterProxy.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void cellSetListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_cellSetListValueChanged
    {//GEN-HEADEREND:event_cellSetListValueChanged
        if (aCS != null)
        for (int i = 0; i < aCS.length; i++)
            aCS[i] = cellSetList.isSelectedIndex(i);
        parameterProxy.set(SELECTED_CELL_SETS, aCS);
    }//GEN-LAST:event_cellSetListValueChanged

    private void bdrCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_bdrCheckBoxActionPerformed
    {//GEN-HEADEREND:event_bdrCheckBoxActionPerformed
        parameterProxy.set(BOUNDARY_ISOLINES, bdrCheckBox.isSelected());
    }//GEN-LAST:event_bdrCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JCheckBox bdrCheckBox;
    public javax.swing.JList cellSetList;
    public javax.swing.JScrollPane cellSetScrollPane;
    public javax.swing.JPanel cropPresentationPanel;
    public org.visnow.vn.lib.gui.cropUI.CropUI cropUI;
    public javax.swing.Box.Filler filler;
    public javax.swing.JPanel preprocessingPanel;
    public javax.swing.JPanel preprocessingRegularPanel;
    public org.visnow.vn.gui.widgets.SectionHeader preprocessingSectionHeader;
    public org.visnow.vn.gui.widgets.RunButton runButton;
    public javax.swing.JPanel thresholdPanel;
    public org.visnow.vn.lib.gui.ComponentBasedUI.array.ComponentValuesArrayUI thresholdsUI;
    public org.visnow.vn.gui.widgets.ExtendedSlider timeSlider;
    public javax.swing.JCheckBox uncertaintyBox;
    // End of variables declaration//GEN-END:variables

}
